diff --git a/examples/systemd/hive-web.service b/examples/systemd/hive-web.service
new file mode 100644
index 0000000..f2110d2
--- /dev/null
+++ b/examples/systemd/hive-web.service
@@ -0,0 +1,57 @@
+# Sample systemd-user unit for the hive web UI (Linux).
+#
+# `hive web install` writes this file for you (rewriting ExecStart= and
+# Environment= to match the resolved binary + Ruby manager detected on
+# the host). This template exists so operators can inspect the shape,
+# hand-install on a machine without a resolved hive binary, or diff
+# against what was installed.
+#
+# Install:
+#   mkdir -p ~/.config/systemd/user
+#   $EDITOR examples/systemd/hive-web.service           # confirm ExecStart=
+#   cp examples/systemd/hive-web.service ~/.config/systemd/user/
+#   systemctl --user daemon-reload
+#   systemctl --user enable --now hive-web
+#
+# The unit runs `hive web` in the FOREGROUND — systemd is the supervisor,
+# Restart=on-failure brings the UI back if it crashes. The web UI and the
+# daemon are deliberately SEPARATE services (hive-daemon / hive-web):
+# restarting one must never take the other down.
+#
+# Verify:
+#   systemctl --user status hive-web
+#   curl -fsS http://127.0.0.1:4567/health
+#
+# View logs:
+#   journalctl --user -u hive-web -f
+#
+# Stop / restart:
+#   systemctl --user stop hive-web
+#   systemctl --user restart hive-web
+
+[Unit]
+Description=Hive web UI (local mode)
+After=default.target
+StartLimitBurst=3
+StartLimitIntervalSec=300
+
+[Service]
+Type=simple
+# systemd user services do NOT inherit your interactive shell's PATH.
+#   1. HIVE_BIN — absolute path to the hive binary.
+#   2. PATH — covers the gem's bin/hive wrapper (`#!/usr/bin/env ruby`
+#      needs a Ruby with the gem's dependencies) plus any incidental
+#      shell-outs. `hive web install` prepends mise/rbenv/asdf shim
+#      directories automatically when a Ruby manager is detected.
+Environment=HIVE_BIN=%h/.local/bin/hive
+Environment=PATH=%h/.local/bin:/usr/local/bin:/usr/bin:/bin
+ExecStart=%h/.local/bin/hive web
+Restart=on-failure
+RestartSec=30s
+# The Rails server answers SIGTERM with a graceful Puma shutdown; a wide
+# margin avoids SIGKILL mid-request during restarts.
+KillMode=mixed
+TimeoutStopSec=90
+
+[Install]
+WantedBy=default.target
diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0..e070d94 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -25,7 +25,7 @@ module Hive
       "hive-forget" => 1,
       "hive-drop" => 2,
       "hive-prune" => 1,
-      "hive-daemon-status" => 1,
+      "hive-daemon-status" => 2,
       "hive-daemon-stop" => 1,
       "hive-daemon-enroll" => 1,
       "hive-daemon-reload" => 1,
@@ -57,6 +57,17 @@ module Hive
       "hive-bot-stop" => 1,
       "hive-bot-reload" => 1,
       "hive-bot-install" => 1,
+      # Managed web service (`hive web install|start|stop|status`). The
+      # hive-web unit is separate from hive-daemon; install mirrors
+      # hive-daemon-install's outcome enum, stop/start report the
+      # service-manager action result, status is the non-mutating probe
+      # (unit state + /health?deep=1 + port liveness).
+      "hive-web-install" => 1,
+      "hive-web-stop" => 1,
+      "hive-web-status" => 1,
+      # One-command local setup (`hive setup --json`). The envelope carries
+      # the dependency-matrix rows, actions taken, and the final web URL.
+      "hive-setup" => 1,
       # File-backed dispatch request the bot writes for the daemon to
       # consume. One JSON file per pending request under the state-home
       # `dispatch_requests/` directory. See
diff --git a/lib/hive/cli.rb b/lib/hive/cli.rb
index cd80906..a3c8c13 100644
--- a/lib/hive/cli.rb
+++ b/lib/hive/cli.rb
@@ -1332,14 +1332,66 @@ module Hive
       ).call
     end
 
-    desc "web", "Run the hivebox web UI"
-    option :bind, type: :string, desc: "override web.bind"
-    option :port, type: :numeric, desc: "override web.port"
-    def web
+    desc "web [SUBCOMMAND]", "Run the hive web UI in the foreground, or manage it as a service (install / start / stop / status)"
+    long_desc <<~DESC
+      Bare `hive web` boots the Rails web UI in the foreground — the
+      long-standing contract, unchanged. The subcommands register it as a
+      per-user managed service (systemd-user on Linux, launchd on macOS),
+      separate from `hive-daemon`:
+
+        install [--force] [--no-autostart] [--json]
+                        Write the hive-web unit. Without --force, refuses to
+                        overwrite a pre-existing unit and exits 64. With
+                        --force, backs up the previous file to a timestamped
+                        <path>.bak-<UTC-stamp> and restarts the running
+                        service so new Environment= lines take effect.
+        start [--json]  Start the managed web service now.
+        stop [--json]   Stop the managed web service (idempotent).
+        status [--json] Non-mutating probe: unit installed/enabled, /health
+                        deep check, port liveness.
+
+      App discovery order:
+        1. HIVEBOX_WEB_APP_DIR (operator override / Docker image)
+        2. a source checkout (web/ next to the gem source)
+        3. the Hive-managed copy provisioned by `hive setup`
+           (~/.local/share/hive/web/app/<version>)
+
+      On a machine with none of those, pass --yes to provision the managed
+      copy on demand (downloads the release tarball + builds the bundle),
+      or run `hive setup` once instead.
+
+      Auth: with the default loopback bind (127.0.0.1:4567) and no claimed
+      owner, the UI grants a tokenless local session — no login. A
+      non-loopback bind with no auth available is refused unless
+      --allow-public-noauth is passed (unsafe). The Docker/hivebox path
+      keeps its GitHub device-flow owner gate.
+    DESC
+    option :bind, type: :string, desc: "override web.bind (foreground)"
+    option :port, type: :numeric, desc: "override web.port (foreground)"
+    option :yes, type: :boolean, default: false,
+                 desc: "provision the managed web app on demand if no app is found"
+    option :allow_public_noauth, type: :boolean, default: false,
+                                 desc: "UNSAFE: allow a tokenless (no-auth) web UI on a non-loopback bind"
+    option :force, type: :boolean, default: false,
+                   desc: "for install: overwrite an existing unit (saves <path>.bak)"
+    option :no_autostart, type: :boolean, default: false,
+                          desc: "for install: write the unit without enabling autostart"
+    def web(subcommand = nil)
+      if subcommand
+        require "hive/commands/web_service"
+        return Hive::Commands::WebService.new(
+          subcommand,
+          json: options[:json],
+          force: options[:force],
+          autostart: !options[:no_autostart]
+        ).call
+      end
+
       if options[:json]
         require "json"
         message = "hive web has no JSON output (it runs a long-lived server). " \
-                  "Use 'hive status --json' for machine-readable task data."
+                  "Use 'hive status --json' for machine-readable task data, or " \
+                  "'hive web status --json' for the managed web service."
         # Mirror `hive tui`'s rejection: emit a structured error envelope (sans
         # `schema`, since web has no registered hive-* schema) and raise
         # InvalidTaskPath for the USAGE (64) exit code — parity with every
@@ -1355,7 +1407,66 @@ module Hive
       end
 
       require "hive/commands/web"
-      Hive::Commands::Web.new(bind: options[:bind], port: options[:port]).call
+      Hive::Commands::Web.new(
+        bind: options[:bind],
+        port: options[:port],
+        allow_public_noauth: options[:allow_public_noauth],
+        assume_yes: options[:yes]
+      ).call
+    end
+
+    desc "setup", "One-command local setup: deps, daemon service, project enrollment, web UI"
+    long_desc <<~DESC
+      Provisions and validates a complete local (non-Docker) Hive install:
+
+        1. Dependency matrix — external CLIs (git, tmux, gh, claude, codex,
+           node/npm) are CHECKED ONLY; each missing one is reported with its
+           exact fix command and is never installed or authenticated here.
+           Hive-owned deps (qmd, the web bundle) are repaired automatically.
+        2. Agent backends — on a TTY, prompts which backends to persist
+           globally (Enter accepts the recommended defaults); non-TTY runs
+           take the defaults silently.
+        3. Daemon — installs the hive-daemon service when missing, repairs
+           binary drift (install --force), starts it when down, and enrolls
+           the current project (TTY-prompted default Y at `hive init`; the
+           enrollment here is unconditional unless --no-enroll).
+        4. Web — provisions the web bundle, then installs + starts the
+           managed hive-web service (http://127.0.0.1:4567 by default).
+           --foreground-web runs `hive web` in the terminal instead, and
+           --skip-web skips the web tier entirely.
+
+      Idempotent — safe to re-run as a repair tool.
+
+      Flags:
+        --json             emit hive-setup.v1 (rows/actions/URLs; ok=false
+                           when blockers remain)
+        --project PATH     project root to enroll (default: cwd)
+        --skip-web         skip provisioning + the web service
+        --skip-daemon      skip daemon install/start/enrollment
+        --foreground-web   run `hive web` in the foreground after setup
+                           instead of the managed service
+        --no-enroll        skip project enrollment
+
+      Exit codes: 0 when the web-critical path is green; 65 when blockers
+      remain (each row explains exactly what's left).
+    DESC
+    option :project, type: :string, desc: "project root to enroll (default: cwd)"
+    option :skip_web, type: :boolean, default: false, desc: "skip the web tier"
+    option :skip_daemon, type: :boolean, default: false, desc: "skip the daemon service"
+    option :foreground_web, type: :boolean, default: false,
+                            desc: "run `hive web` in the foreground instead of the managed service"
+    option :no_enroll, type: :boolean, default: false, desc: "skip project enrollment"
+    def setup
+      require "hive/commands/setup"
+      exit_code = Hive::Commands::Setup.new(
+        project: options[:project],
+        json: options[:json],
+        skip_web: options[:skip_web],
+        skip_daemon: options[:skip_daemon],
+        foreground_web: options[:foreground_web],
+        enroll: !options[:no_enroll]
+      ).call
+      exit exit_code
     end
 
     desc "tui", "Open the live, keystroke-driven dashboard for every active task"
diff --git a/lib/hive/commands/daemon.rb b/lib/hive/commands/daemon.rb
index 6c91610..69aa2f0 100644
--- a/lib/hive/commands/daemon.rb
+++ b/lib/hive/commands/daemon.rb
@@ -371,6 +371,7 @@ module Hive
 
         if @json
           service_state = probe_service_state
+          consistency = probe_consistency
           puts JSON.generate(
             "schema" => "hive-daemon-status",
             "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-daemon-status"),
@@ -383,6 +384,11 @@ module Hive
             "service_installed" => service_state["service_installed"],
             "service_enabled" => service_state["service_enabled"],
             "unit_path" => service_state["unit_path"],
+            # v2 additive block (U5): binary/version consistency between the
+            # invoking CLI and the installed unit / live daemon process.
+            # Read-only; null when the probe could not run (unsupported
+            # platform, unreadable unit, …).
+            "consistency" => consistency,
             # Agent-native parity with the TUI footer / bot push: expose the
             # update nudge so a programmatic caller can detect "behind" too.
             "current_version" => Hive::VERSION,
@@ -409,6 +415,23 @@ module Hive
         { "service_installed" => nil, "service_enabled" => nil, "unit_path" => nil }
       end
 
+      # U5: binary/version consistency probe for the status envelope. Same
+      # degrade-to-null contract as probe_service_state — a probe failure
+      # must never take down `hive daemon status`.
+      def probe_consistency
+        require "hive/daemon/consistency_probe"
+        running_pid = nil
+        if File.exist?(pid_file)
+          payload = read_pid_file_payload
+          candidate = payload && payload["pid"]
+          running_pid = candidate if candidate && candidate > 0 &&
+                                    pid_alive?(candidate) && pid_owned_by_us?(payload, candidate)
+        end
+        Hive::Daemon::ConsistencyProbe.new(pid: running_pid).call.to_h
+      rescue StandardError
+        nil
+      end
+
       # The daemon-written update nudge, as a plain Hash for the status
       # envelope (nil when current or unknown). Never raises out of status.
       def update_nudge_payload
diff --git a/lib/hive/commands/doctor.rb b/lib/hive/commands/doctor.rb
index 99afbc0..f6241fb 100644
--- a/lib/hive/commands/doctor.rb
+++ b/lib/hive/commands/doctor.rb
@@ -9,6 +9,7 @@ require "hive/agent_profiles/claude"
 require "hive/agent_profiles/codex"
 require "hive/agent_profiles/pi"
 require "hive/claude_launcher"
+require "hive/qmd_lookup"
 
 module Hive
   module Commands
@@ -54,7 +55,7 @@ module Hive
       end
 
       def call
-        @rows = check_tmux + check_llm_wiki_qmd + check_legacy_brainstorm_runtime + check_stages + check_reviewers
+        @rows = check_tmux + check_llm_wiki_qmd + check_legacy_brainstorm_runtime + check_daemon_binary + check_stages + check_reviewers
         if @json
           @output.puts JSON.generate(envelope(@rows))
         else
@@ -161,34 +162,60 @@ module Hive
         ) ]
       end
 
-      def find_qmd
-        env_qmd = ENV["HIVE_QMD_BIN"].to_s
-        return env_qmd if !env_qmd.empty? && File.executable?(env_qmd)
-
-        path_qmd = which("qmd")
-        return path_qmd if path_qmd
-
-        data_home = ENV["XDG_DATA_HOME"].to_s.empty? ? File.expand_path("~/.local/share") : ENV["XDG_DATA_HOME"]
-        candidates = [
-          File.join(data_home, "hive", "qmd", "bin", "qmd"),
-          File.expand_path("~/.local/share/hive/qmd/bin/qmd")
+      # U5: binary/version consistency row for the daemon. `present` when the
+      # invoking CLI matches the installed unit / live daemon binary;
+      # `warning` (drifted) with the exact repair command when the unit bakes
+      # a different binary (e.g. a stale unit pointing at /usr/bin/hive) or
+      # the live process argv differs. A drifted daemon is a WARNING, not a
+      # missing skill — it must not flip doctor's exit code, only surface the
+      # fix hint.
+      def check_daemon_binary
+        require "hive/daemon/consistency_probe"
+        probe = Hive::Daemon::ConsistencyProbe.new.call
+        base = {
+          kind: "dependency",
+          stage: "daemon",
+          label: "daemon/binary",
+          agent: "daemon",
+          configured_skill: "hive daemon",
+          skill: "hive daemon"
+        }
+        return [ base.merge(status: "present", message: probe.cli_bin_path.to_s) ] unless probe.drifted?
+
+        detail = case probe.drift_kind
+                 when Hive::Daemon::ConsistencyProbe::DRIFT_UNIT_PATH
+                   "unit bakes #{probe.unit_bin_path} but the CLI resolves to #{probe.cli_bin_path}"
+                 when Hive::Daemon::ConsistencyProbe::DRIFT_LIVE_BIN
+                   "running daemon (pid #{probe.pid}) executes #{probe.live_bin_path} but the CLI resolves to #{probe.cli_bin_path}"
+                 else
+                   probe.drift_kind
+                 end
+        [ base.merge(
+          status: "warning",
+          message: "daemon binary drifted: #{detail}; repair with `hive daemon install --force` " \
+                   "(the running daemon restarts with the current binary; a timestamped .bak of the old unit is kept)"
+        ) ]
+      rescue StandardError => e
+        [
+          {
+            kind: "dependency",
+            stage: "daemon",
+            label: "daemon/binary",
+            agent: "daemon",
+            configured_skill: "hive daemon",
+            skill: "hive daemon",
+            status: "warning",
+            message: "daemon binary probe failed (#{e.message}); run `hive daemon status --json` to inspect"
+          }
         ]
+      end
 
-        prefix_file = File.join(data_home, "hive", "install-prefix")
-        if File.readable?(prefix_file)
-          prefix = File.read(prefix_file).lines.first.to_s.strip
-          candidates << File.join(prefix, "hive", "qmd", "bin", "qmd") unless prefix.empty?
-        end
-
-        candidates.find { |candidate| File.file?(candidate) && File.executable?(candidate) }
+      def find_qmd
+        Hive::QmdLookup.qmd_bin
       end
 
       def which(name)
-        ENV["PATH"].to_s.split(File::PATH_SEPARATOR).each do |dir|
-          path = File.join(dir, name)
-          return path if File.file?(path) && File.executable?(path)
-        end
-        nil
+        Hive::QmdLookup.which(name)
       end
 
       def first_diagnostic_line(*parts)
